VERSION 5.00
Begin VB.Form frmModifyUserDetails 
   Caption         =   "Modify User Details"
   ClientHeight    =   7590
   ClientLeft      =   405
   ClientTop       =   510
   ClientWidth     =   9015
   LinkTopic       =   "Form1"
   ScaleHeight     =   7590
   ScaleWidth      =   9015
   Begin VB.Frame Frame3 
      Height          =   2055
      Left            =   120
      TabIndex        =   19
      Top             =   120
      Width           =   8655
      Begin VB.PictureBox Picture1 
         AutoRedraw      =   -1  'True
         AutoSize        =   -1  'True
         Height          =   1260
         Left            =   840
         Picture         =   "frmModifyUserDetails.frx":0000
         ScaleHeight     =   1200
         ScaleWidth      =   6960
         TabIndex        =   20
         Top             =   480
         Width           =   7020
      End
   End
   Begin VB.Frame Frame1 
      Caption         =   "Details"
      Height          =   5175
      Left            =   120
      TabIndex        =   10
      Top             =   2280
      Width           =   8775
      Begin VB.ListBox lstGroups 
         Height          =   2010
         Left            =   1560
         TabIndex        =   7
         Top             =   2280
         Width           =   4455
      End
      Begin VB.TextBox txtExpiryDate 
         Height          =   375
         Left            =   1560
         TabIndex        =   5
         Top             =   1800
         Width           =   2415
      End
      Begin VB.Frame Frame2 
         Caption         =   "Account Status"
         Height          =   1575
         Left            =   6240
         TabIndex        =   18
         Top             =   3360
         Width           =   2175
         Begin VB.CheckBox chkAccountLocked 
            Caption         =   "Account Locked"
            Height          =   495
            Left            =   240
            TabIndex        =   9
            TabStop         =   0   'False
            Top             =   840
            Width           =   1815
         End
         Begin VB.CheckBox chkAccountDisabled 
            Caption         =   "Account Disabled"
            Height          =   375
            Left            =   240
            TabIndex        =   8
            TabStop         =   0   'False
            Top             =   360
            Width           =   1695
         End
      End
      Begin VB.TextBox txtBadLoginCount 
         Height          =   375
         Left            =   1560
         TabIndex        =   17
         TabStop         =   0   'False
         Top             =   4440
         Width           =   2415
      End
      Begin VB.CommandButton cmdChangeExpiryDate 
         Caption         =   "Change Date!"
         BeginProperty Font 
            Name            =   "Comic Sans MS"
            Size            =   12
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   405
         Left            =   4080
         TabIndex        =   6
         Top             =   1800
         Width           =   1935
      End
      Begin VB.CommandButton cmdSetPassword 
         Caption         =   "Set Password!"
         BeginProperty Font 
            Name            =   "Comic Sans MS"
            Size            =   12
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   405
         Left            =   4080
         TabIndex        =   4
         Top             =   1320
         Width           =   1935
      End
      Begin VB.CommandButton cmdFindUser 
         Caption         =   "Find User!"
         BeginProperty Font 
            Name            =   "Comic Sans MS"
            Size            =   12
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   405
         Left            =   4200
         TabIndex        =   1
         Top             =   360
         Width           =   1695
      End
      Begin VB.TextBox txtDisplayName 
         Height          =   375
         Left            =   1560
         TabIndex        =   2
         TabStop         =   0   'False
         Top             =   840
         Width           =   4455
      End
      Begin VB.TextBox txtPassword 
         Height          =   375
         IMEMode         =   3  'DISABLE
         Left            =   1560
         PasswordChar    =   "*"
         TabIndex        =   3
         Top             =   1320
         Width           =   2415
      End
      Begin VB.TextBox txtUsername 
         Height          =   375
         Left            =   1560
         TabIndex        =   0
         Top             =   360
         Width           =   2415
      End
      Begin VB.Label Label6 
         Caption         =   "Bad Login Count:"
         Height          =   255
         Left            =   240
         TabIndex        =   16
         Top             =   4440
         Width           =   1335
      End
      Begin VB.Label Label5 
         Caption         =   "Groups:"
         Height          =   255
         Left            =   840
         TabIndex        =   15
         Top             =   2280
         Width           =   615
      End
      Begin VB.Label Label4 
         Caption         =   "Expiry Date:"
         Height          =   255
         Left            =   600
         TabIndex        =   14
         Top             =   1800
         Width           =   855
      End
      Begin VB.Label Label3 
         Caption         =   "Password:"
         Height          =   255
         Left            =   600
         TabIndex        =   13
         Top             =   1440
         Width           =   855
      End
      Begin VB.Label Label2 
         Caption         =   "Full Name:"
         Height          =   255
         Left            =   600
         TabIndex        =   12
         Top             =   960
         Width           =   855
      End
      Begin VB.Label Label1 
         Caption         =   "Username:"
         Height          =   255
         Left            =   600
         TabIndex        =   11
         Top             =   480
         Width           =   855
      End
   End
End
Attribute VB_Name = "frmModifyUserDetails"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Const ROOT = "LDAP://dc=mycorp,dc=com"

Dim strUserName As String
Dim strUserPath As String

Private Sub cmdFindUser_Click()
    Dim arrPaths() As String
    Dim adsUser As ActiveDs.IADsUser
    Dim adsGroup As ActiveDs.IADsGroup
    Dim strBLC As String
    
    If txtUsername.Text = "" Then
        MsgBox "You must specify a username before clicking Find.", vbCritical, "Username invalid"
        txtUsername.Text = strUserName
        Exit Sub
    End If
    
    If Not SearchAD(ROOT, "(cn=" & txtUsername.Text & ")", "SubTree", arrPaths) Then
        'User does not exist
        MsgBox "A user called (" & txtUsername.Text & ") does not exist.", vbCritical, "Username invalid"
    
        'Disable the controls
        chkAccountDisabled.Enabled = False
        cmdSetPassword.Enabled = False
        cmdChangeExpiryDate.Enabled = False
        txtPassword.Enabled = False
        txtExpiryDate.Enabled = False
        txtPassword.Text = ""
        txtDisplayName.Text = ""
        txtExpiryDate.Text = ""
        txtBadLoginCount.Text = ""
        lstGroups.Clear
    Else
        'Erase all existing values
        txtPassword.Text = ""
        txtDisplayName.Text = ""
        txtExpiryDate.Text = ""
        txtBadLoginCount.Text = ""
        lstGroups.Clear
        frmModifyUserDetails.Refresh
        
        'User exists so bind to it
        strUserName = txtUsername.Text
        strUserPath = arrPaths(0)
        Set adsUser = GetObject(strUserPath)
        adsUser.GetInfo
        
        'Fill in values
        txtDisplayName.Text = adsUser.Get("displayName")
        txtExpiryDate.Text = adsUser.AccountExpirationDate
        If adsUser.AccountDisabled Then
            'Check the disabled box
            chkAccountDisabled = 1
        Else
            'Uncheck the disabled box
            chkAccountDisabled = 0
        End If
        If adsUser.IsAccountLocked Then
            'Check the locked box
            chkAccountLocked = 1
            'Enable the checkbox so that the account can be unlocked
            chkAccountLocked.Enabled = True
        Else
            'Uncheck the locked box
            chkAccountLocked = 0
        End If
        For Each adsGroup In adsUser.Groups
            lstGroups.AddItem (adsGroup.Name)
        Next
        
        'Gather the basic user properties for display
        On Error Resume Next
        strBLC = adsUser.BadLoginCount
        If Err Then
            txtBadLoginCount.Text = 0
        Else
            txtBadLoginCount.Text = strBLC
        End If
        
        'Enable the controls
        chkAccountDisabled.Enabled = True
        cmdSetPassword.Enabled = True
        cmdChangeExpiryDate.Enabled = True
        txtPassword.Enabled = True
        txtExpiryDate.Enabled = True
        
        Set adsUser = Nothing
        Set adsGroup = Nothing
    End If
End Sub

Private Sub chkAccountDisabled_Click()
    Dim adsUser As ActiveDs.IADsUser
    
    If chkAccountDisabled.Value = 0 Then
        'Enable account
        Set adsUser = GetObject(strUserPath)
        adsUser.GetInfo
        adsUser.AccountDisabled = False
        adsUser.SetInfo
        MsgBox "The user (" & strUserName & ") has been enabled.", vbInformation, "User enabled"
    Else
        'Disable Account
        Set adsUser = GetObject(strUserPath)
        adsUser.GetInfo
        adsUser.AccountDisabled = True
        adsUser.SetInfo
        MsgBox "The user (" & strUserName & ") has been disabled.", vbInformation, "User disabled"
    End If
    
    Set adsUser = Nothing
End Sub

Private Sub chkAccountLocked_Click()
    Dim adsUser As ActiveDs.IADsUser
    
    If chkAccountLocked.Value = 0 Then
        'Unlock the account
        Set adsUser = GetObject(strUserPath)
        adsUser.GetInfo
        adsUser.IsAccountLocked = False
        adsUser.SetInfo
        MsgBox "The user (" & strUserName & ") has been unlocked.", vbInformation, "User enabled"
    End If
   
    'Disable the checkbox
    chkAccountLocked.Enabled = False
   
    Set adsUser = Nothing
End Sub

Private Sub cmdSetPassword_Click()
    Dim adsUser As ActiveDs.IADsUser

    Set adsUser = GetObject(strUserPath)
    adsUser.GetInfo
    
    If txtPassword.Text = "" Then
        MsgBox "The password cannot be empty.", vbExclamation, "User password change"
    ElseIf Len(txtPassword) < 6 Then
        MsgBox "The password cannot be less than 6 characters long.", vbExclamation, "User password change"
    Else
        adsUser.SetPassword txtPassword.Text
        'Place error checking here as you require
        MsgBox "The password has been changed to (" & txtPassword.Text & ").", vbInformation, "User password change"
    End If
    txtPassword.Text = ""
    Set adsUser = Nothing
End Sub

Private Sub cmdChangeExpiryDate_Click()
    Dim adsUser As ActiveDs.IADsUser

    Set adsUser = GetObject(strUserPath)
    adsUser.GetInfo
    
    If txtExpiryDate.Text = "" Then
        MsgBox "The expiry date cannot be empty.", vbExclamation, "User expiry date change"
        txtExpiryDate.Text = adsUser.AccountExpirationDate
    Else
        On Error Resume Next
        adsUser.AccountExpirationDate = txtExpiryDate.Text
        adsUser.SetInfo
        If Err Then
            MsgBox "The expiry date has not been changed due to an error.", vbCritical, "User expiry date change"
        Else
            MsgBox "The expiry date been changed to (" & txtExpiryDate.Text & ").", vbInformation, "User expiry date change"
        End If
    End If
    
    Set adsUser = Nothing
End Sub

Public Function SearchAD(ByVal strLDAPBase As String, ByVal strCriteria As String, _
                            ByVal strDepth As String, arrADsPaths() As String) As Boolean
    
    Dim adoConnection As New ADODB.Connection
    Dim adoCommand As New ADODB.Command
    Dim adoRecordset  As ADODB.Recordset
    Dim intArrayIndex As Integer

    adoConnection.Provider = "ADSDSOObject"
    adoConnection.Open "", vbNullString, vbNullString
    If adoConnection.State = adStateClosed Then
        SearchAD = False
    End If
    
    Set adoCommand.ActiveConnection = adoConnection
    adoCommand.CommandText = "<" & strLDAPBase & ">;" & strCriteria & ";ADsPath;" & strDepth
    adoCommand.Properties("Timeout") = 30                                   'seconds
    adoCommand.Properties("searchscope") = ADS_SCOPE_SUBTREE                'Define in ADS_SCOPEENUM
    adoCommand.Properties("Chase referrals") = ADS_CHASE_REFERRALS_EXTERNAL
    adoCommand.Properties("Cache Results") = False                          'do not cache the result set

    On Error Resume Next
    Set adoRecordset = adoCommand.Execute
    If Err Then
        adoConnection.Close
        Set adoRecordset = Nothing
        SearchAD = False
    Else
        If adoRecordset.EOF Then
            adoConnection.Close
            Set adoRecordset = Nothing
            SearchAD = False
        Else
            ReDim arrADsPaths(adoRecordset.RecordCount - 1) As String
            
            intArrayIndex = 0
            While Not adoRecordset.EOF
                arrADsPaths(intArrayIndex) = adoRecordset.Fields.Item("ADsPath").Value
                intArrayIndex = intArrayIndex + 1
                adoRecordset.MoveNext
            Wend
            adoConnection.Close
            Set adoRecordset = Nothing
            SearchAD = True
        End If
    End If
End Function


